> ## Documentation Index
> Fetch the complete documentation index at: https://docs.seekr.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update tool

> Partially update an existing tool. Omitted fields remain unchanged.

Tool type cannot be changed after creation. If you include the `type` field in your request, it must match the existing tool type.

> ❗ Important
>
> Tool updates propagate immediately to all agents using the tool.

## MCP connector

You can update `name` and `description`. If you need to connect to a different server or change credentials, create a new MCP connector tool and update your agent's `tool_ids`.

## Agent as tool

You can update `name` and `description`. The underlying sub-agent cannot be changed. To use a different sub-agent, create a new agent-as-tool for that sub-agent.


## OpenAPI

````yaml patch /v1/flow/tools/{tool_id}
openapi: 3.1.0
info:
  title: SeekrFlow API
  description: SeekrFlow API Documentation
  termsOfService: http://www.seekr.com/support
  contact:
    name: Seekr API Support
    url: http://www.seekr.com/contact
    email: contact@seekr.com
  version: 5.87.1
servers:
  - url: https://flow.seekr.com
    description: SeekrBuild server base URL
security: []
paths:
  /v1/flow/tools/{tool_id}:
    patch:
      tags:
        - Tools
      summary: Update tool
      description: Partially update an existing tool. Omitted fields remain unchanged.
      operationId: patch_tool_v1_flow_tools__tool_id__patch
      parameters:
        - name: tool_id
          in: path
          required: true
          schema:
            type: string
            title: Tool Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchToolBaseRequest'
            examples:
              file_search:
                summary: File search patch request
                value:
                  name: my file search tool
                  description: 'contains files about '
                  config:
                    file_search_index: my-document-index
                    top_k: 10
                    score_threshold: 0.7
              run_python:
                summary: Code interpreter / Custom functions patch request
                value:
                  name: my python functions tool
                  description: Execute Python code for data analysis and calculations
                  config:
                    function_ids:
                      - func-123
                      - func-456
              web_search:
                summary: Web search patch request
                value:
                  name: my web search tool
                  description: Search the web for current information
              agent_as_tool:
                summary: Agent as tool patch request
                value:
                  name: sports history bot
                  description: an expert on the history of sports
              mcp_connector:
                summary: MCP Connector Tool patch request
                value:
                  name: mcp connector tool
                  description: MCP connector tool with external authorization
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                oneOf:
                  - $ref: '#/components/schemas/FileSearchResponse'
                  - $ref: '#/components/schemas/RunPythonResponse'
                  - $ref: '#/components/schemas/WebSearchResponse'
                  - $ref: '#/components/schemas/AgentAsToolResponse'
                  - $ref: '#/components/schemas/MCPConnectorToolResponse'
                discriminator:
                  propertyName: type
                  mapping:
                    file_search:
                      $ref: '#/components/schemas/FileSearchResponse'
                    run_python:
                      $ref: '#/components/schemas/RunPythonResponse'
                    web_search:
                      $ref: '#/components/schemas/WebSearchResponse'
                    agent_as_tool:
                      $ref: '#/components/schemas/AgentAsToolResponse'
                    mcp_connector:
                      $ref: '#/components/schemas/MCPConnectorToolResponse'
                title: Response Patch Tool V1 Flow Tools  Tool Id  Patch
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    PatchToolBaseRequest:
      properties:
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          anyOf:
            - $ref: '#/components/schemas/ToolType'
            - type: 'null'
        config:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Config
      additionalProperties: false
      type: object
      title: PatchToolBaseRequest
    FileSearchResponse:
      properties:
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          type: string
          const: file_search
          title: Type
          default: file_search
        config:
          $ref: '#/components/schemas/FileSearchConfig'
        user_id:
          type: string
          title: User Id
        team_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Team Id
        status:
          $ref: '#/components/schemas/ToolStatus'
        version:
          type: integer
          title: Version
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - id
        - name
        - config
        - user_id
        - team_id
        - status
        - version
        - created_at
        - updated_at
      title: FileSearchResponse
    RunPythonResponse:
      properties:
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          type: string
          const: run_python
          title: Type
          default: run_python
        config:
          $ref: '#/components/schemas/RunPythonConfig'
          default: {}
        user_id:
          type: string
          title: User Id
        team_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Team Id
        status:
          $ref: '#/components/schemas/ToolStatus'
        version:
          type: integer
          title: Version
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - id
        - name
        - user_id
        - team_id
        - status
        - version
        - created_at
        - updated_at
      title: RunPythonResponse
    WebSearchResponse:
      properties:
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          type: string
          const: web_search
          title: Type
          default: web_search
        user_id:
          type: string
          title: User Id
        team_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Team Id
        status:
          $ref: '#/components/schemas/ToolStatus'
        version:
          type: integer
          title: Version
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - id
        - name
        - user_id
        - team_id
        - status
        - version
        - created_at
        - updated_at
      title: WebSearchResponse
    AgentAsToolResponse:
      properties:
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          type: string
          const: agent_as_tool
          title: Type
          default: agent_as_tool
        config:
          $ref: '#/components/schemas/AgentAsToolConfig'
        user_id:
          type: string
          title: User Id
        team_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Team Id
        status:
          $ref: '#/components/schemas/ToolStatus'
        version:
          type: integer
          title: Version
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - id
        - name
        - config
        - user_id
        - team_id
        - status
        - version
        - created_at
        - updated_at
      title: AgentAsToolResponse
    MCPConnectorToolResponse:
      properties:
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          type: string
          const: mcp_connector
          title: Type
          default: mcp_connector
        config:
          $ref: '#/components/schemas/MCPConnectorToolResponseConfig'
        user_id:
          type: string
          title: User Id
        team_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Team Id
        status:
          $ref: '#/components/schemas/ToolStatus'
        version:
          type: integer
          title: Version
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - id
        - name
        - config
        - user_id
        - team_id
        - status
        - version
        - created_at
        - updated_at
      title: MCPConnectorToolResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ToolType:
      type: string
      enum:
        - file_search
        - web_search
        - run_python
        - agent_as_tool
        - mcp_connector
      title: ToolType
    FileSearchConfig:
      properties:
        FILE_SEARCH_INDEX:
          type: string
          minLength: 1
          title: File Search Index
        EMBEDDING_MODEL:
          anyOf:
            - type: string
            - type: 'null'
          title: Embedding Model
        TOP_K:
          type: integer
          maximum: 100
          minimum: 1
          title: Top K
          description: Top K must be >= 1 and <= 100
          default: 10
        SCORE_THRESHOLD:
          type: number
          exclusiveMaximum: 1
          minimum: 0
          title: Score Threshold
          description: Score must be ≥ 0.0 and < 1.0
          default: 0
      additionalProperties: false
      type: object
      required:
        - FILE_SEARCH_INDEX
      title: FileSearchConfig
    ToolStatus:
      type: string
      enum:
        - Active
        - Inactive
        - Deprecated
        - Pending_authorization
        - Failed
      title: ToolStatus
    RunPythonConfig:
      properties:
        FUNCTION_IDS:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Function Ids
      additionalProperties: false
      type: object
      title: RunPythonConfig
    AgentAsToolConfig:
      properties:
        AGENT_ID:
          type: string
          title: Agent Id
      additionalProperties: false
      type: object
      required:
        - AGENT_ID
      title: AgentAsToolConfig
    MCPConnectorToolResponseConfig:
      properties:
        URL:
          type: string
          minLength: 1
          title: Url
        TRANSPORT:
          type: string
          enum:
            - sse
            - streamable-http
          title: Transport
          default: streamable-http
        AUTHORIZATION_URL:
          anyOf:
            - type: string
            - type: 'null'
          title: Authorization Url
      additionalProperties: false
      type: object
      required:
        - URL
      title: MCPConnectorToolResponseConfig
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      description: Seekr API Key without 'Bearer' Prefix
      in: header
      name: Authorization

````